EDIT - feature request #7463

Move taxonnodes should be available for multiple selection
06/08/2018 12:10 PM - Katja Luther

Status: Closed Start date:
Priority: Highest Due date:

Assignee: Katja Luther % Done:

Category: taxeditor Estimated time:

Target version: Release 5.1

Severity: major

100%
0:00 hour

Description
Open issues:

¢ Exception in #7463#note-6

o refresh after task end #7463#note-8

® report (e.g. count of moved nodes)

e (progress monitor shows correct percentage) ...

¢ exclude-move-with-new-parent—=-old-parent

Related issues:

Related to EDIT - feature request #7464: make move Taxonnodes a longrunning task
Related to EDIT - feature request #6321: Implement parallel loading + progres...
Related to EDIT - bug #7521: refresh of taxonnavigator sometimes does not wor...

Closed
Closed
Closed

Associated revisions

Revision 0fde7fba - 06/07/2018 09:38 PM - Katja Luther

allow multiple selection for moving taxonnodes

Revision 63e69bf5 - 06/18/2018 09:48 AM - Katja Luther

ref #7463: add only moved nodes to resultSet of moveTaxonNodes

Revision 1385d1b6 - 06/18/2018 10:00 AM - Katja Luther

ref #7463: do not move children of a moved node to the new parent but keep it as children

Revision 3f6bdfe5 - 06/18/2018 10:37 AM - Katja Luther

ref #7463: don't allow drag and drop to same parent

Revision Oac7eec9 - 06/18/2018 11:51 AM - Katja Luther

ref #7463: preselect of the classification by the classification of the first selected node

Revision d28a05d3 - 06/21/2018 04:34 PM - Katja Luther

ref #7463:add subtask for saving and reindexing in moveTaxonNodes

Revision 09376415 - 06/21/2018 04:35 PM - Katja Luther

ref #7463: adapt the percentage display in status bar for progress of longrunning task

Revision 83d0e22f - 06/21/2018 04:57 PM - Katja Luther

ref #7463: adapt the percentage display in status bar for progress of longrunning task

History

#1 - 06/08/2018 12:11 PM - Katja Luther

at the moment moving taxon node is only available for a single node, we should provide it also for a set of nodes.

#2 - 06/08/2018 12:13 PM - Katja Luther
https://dev.e-taxonomy.eu/redmine/issues/7463#note-6
https://dev.e-taxonomy.eu/redmine/issues/7463#note-8

- Tracker changed from bug to feature request

#3 - 06/08/2018 12:13 PM - Katja Luther

- Related to feature request #7464: make move Taxonnodes a longrunning task added

#4 - 06/13/2018 02:09 PM - Katja Luther
- Status changed from New to Resolved

- Assignee changed from Katja Luther to Andreas Mdiller

please review

#5 - 06/13/2018 02:09 PM - Katja Luther
- % Done changed from 0 to 50

#6 - 06/15/2018 12:22 AM - Andreas Miiller
- Status changed from Resolved to Feedback

- Assignee changed from Andreas Muiller to Katja Luther

While testing | got the following exception:

login : admin
editor version : 5.1.0.201806142059
server : test.e-taxonomy.eu (edit-test) / rem_conf_am
schema version : 5.0.0.0.20180514
os : Windows Server 2012 R2 6.3 amd64
java : 1.8.0_121
org.springframework.remoting.RemoteAccessException: Could not access HTTP invoker remote service at [http://te
st.e-taxonomy.eu:80/cdmserver/rem_conf_am/remoting/progressmonitor.service]; nested exception is Jjava.io.EOFEx
ception

at org.springframework.remoting.httpinvoker.HttpInvokerClientInterceptor.convertHttpInvokerAccessException
(HttpInvokerClientInterceptor. java:216)

at org.springframework.remoting.httpinvoker.HttpInvokerClientInterceptor.invoke (HttpInvokerClientIntercept
or.java:147)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvocation. java:17

9)

at org.springframework.aop.framework.JdkDynamicAopProxy.invoke (JdkDynamicAopProxy.java:208)

at com.sun.proxy.$Proxy53.getRemotingMonitor (Unknown Source)

at eu.etaxonomy.taxeditor.model.AbstractUtility.executeMoniteredOperation (AbstractUtility. java:681)

at eu.etaxonomy.taxeditor.navigation.navigator.ed.TreeNodeDropAdapterE4$1.run (TreeNodeDropAdapterE4. java:2
30)

at org.eclipse.swt.widgets.RunnableLock.run (RunnableLock. java:35)

at org.eclipse.swt.widgets.Synchronizer.runAsyncMessages (Synchronizer. java:182)

at org.eclipse.swt.widgets.Display.runAsyncMessages (Display.java:4211)

at org.eclipse.swt.widgets.Display.readAndDispatch (Display.java:3827)

at org.eclipse.ed.ui.internal.workbench.swt.PartRenderingEngine$4.run (PartRenderingEngine. java:1121)
at org.eclipse.core.databinding.observable.Realm.runWithDefault (Realm. java:336)

at org.eclipse.e4.ui.internal.workbench.swt.PartRenderingEngine.run (PartRenderingEngine. java:1022)
at org.eclipse.ed.ui.internal.workbench.E4Workbench.createAndRunUI (E4Workbench. java:150)

at org.eclipse.ui.internal.Workbench$5.run (Workbench. java:693)

at org.eclipse.core.databinding.observable.Realm.runWithDefault (Realm. java:336)

at org.eclipse.ui.internal.Workbench.createAndRunWorkbench (Workbench. java:610)

at org.eclipse.ui.PlatformUI.createAndRunWorkbench (PlatformUI. java:148)

at eu.etaxonomy.taxeditor.Application.start (Application.java:24)

at org.eclipse.equinox.internal.app.EclipseAppHandle.run (EclipseAppHandle. java:196)

at org.eclipse.core.runtime.internal.adaptor.EclipseAppLauncher.runApplication (EclipseAppLauncher. java:134

at org.eclipse.core.runtime.internal.adaptor.EclipseAppLauncher.start (EclipseAppLauncher.java:104)
at org.eclipse.core.runtime.adaptor.EclipseStarter.run (EclipseStarter.java:388)
at org.eclipse.core.runtime.adaptor.EclipseStarter.run (EclipseStarter. java:243)
at sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)
at sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)
at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)
at java.lang.reflect.Method.invoke (Method. java:498)
at org.eclipse.equinox.launcher.Main.invokeFramework (Main. java:673)
at org.eclipse.equinox.launcher.Main.basicRun (Main. java:610)
at org.eclipse.equinox.launcher.Main.run (Main.java:1519)
Caused by: java.io.EOFException
at java.io.ObjectInputStream$BlockDatalnputStream.peekByte (ObjectInputStream. java:2903)
at java.io.ObjectInputStream.skipCustomData (ObjectInputStream. java:2185)
30 more

#7 - 06/15/2018 12:26 AM - Andreas Miiller

Andreas Muller wrote:

While testing | got the following exception:

... happend only once, usually it seems to work, but maybe the stacktrace gives a hint?

#8 - 06/15/2018 12:27 AM - Andreas Miiller

The tree does not correctly update after the task finished.

#9 - 06/15/2018 12:31 AM - Andreas Miiller

| never got percentage > 0%. Also the "Updated Objects seem not to be clear. It usually shows the number of nodes moved + 2.

#10 - 06/15/2018 12:33 AM - Andreas Miuiller

Critical: when moving a taxon and its children (selected because the subtree was open) | would expect that the subtree structure ist kept but it is not.

The taxa are added to the new parent all as direct children, loosing there own internal parent child relationship.

#11 - 06/15/2018 09:28 AM - Katja Luther

Andreas Muller wrote:

Critical: when moving a taxon and its children (selected because the subtree was open) | would expect that the subtree structure ist kept but it is

not.

The taxa are added to the new parent all as direct children, loosing there own internal parent child relationship.

if you select only the parent the parent child relationship is kept. But if you select parent and children they all are moved to the new parent.

#12 - 06/15/2018 09:33 AM - Katja Luther

Andreas Muller wrote:

| never got percentage > 0%. Also the "Updated Objects seem not to be clear. It usually shows the number of nodes moved + 2.

this is because the new and the old parents are updated, too.

#13 - 06/15/2018 10:01 AM - Katja Luther

Andreas Muller wrote:

The tree does not correctly update after the task finished.

This seems to be the case, when there is an exception and the longrunning task is still running. -> we have to find a solution for catching the
exception
normally the update works correctly.
| currently don't know why, but the handling of the RemotingProgressMonitor (especially the call of
progressMonitorService.getRemotingMonitor(uuid);) takes a lot of time, so, the task of moving nodes is already completed when the first poll for the
monitorthread is done and therefore the percentage keep the 0% till the first poll and then the task is already completed.

This is something we have to work on!

#14 - 06/15/2018 01:50 PM - Andreas Miiller

- Subject changed from move taxonnodes should be available for multiple selection to Move taxonnodes should be available for multiple selection

- Description updated
Katja Luther wrote:

Andreas Muller wrote:

Critical: when moving a taxon and its children (selected because the subtree was open) | would expect that the subtree structure ist kept but
it is not.

The taxa are added to the new parent all as direct children, loosing there own internal parent child relationship.

if you select only the parent the parent child relationship is kept. But if you select parent and children they all are moved to the new parent.

Yes, | know, but the question is, how to improve this. The current situation may lead to unwanted data changes just because users don't
know/understand this behavior.

| would suggest to add something to the algorithm to check if a node which is within the multiselect has a parent/grandparent which is also selected. If
yes, we should not add it to the "move"-operation. Is this easy to check? Easiest would be to use the treeindex. Is it available in the navigator? Or do
we need a service layer method to collect all the "root" nodes for a given set of selected nodes?

#15 - 06/15/2018 02:15 PM - Katja Luther
Andreas Muller wrote:
Katja Luther wrote:
Andreas Muller wrote:

Critical: when moving a taxon and its children (selected because the subtree was open) | would expect that the subtree structure ist
kept but it is not.

The taxa are added to the new parent all as direct children, loosing there own internal parent child relationship.

if you select only the parent the parent child relationship is kept. But if you select parent and children they all are moved to the new parent.

Yes, | know, but the question is, how to improve this. The current situation may lead to unwanted data changes just because users don't
know/understand this behavior.

| would suggest to add something to the algorithm to check if a node which is within the multiselect has a parent/grandparent which is also
selected. If yes, we should not add it to the "move"-operation. Is this easy to check? Easiest would be to use the treeindex. Is it available in the
navigator? Or do we need a service layer method to collect all the "root" nodes for a given set of selected nodes?

| don't know, if this is the expected behaviour. If | select a node to move it as a child to another node | would expect that the node moves to this new
parent independent of its former parent.
But we can check whether one of the nodes is the parent of the other nodes, we have the treeindex available in the navigator.

#16 - 06/15/2018 02:18 PM - Andreas Miiller

- Description updated

Katja Luther wrote:
Andreas Muller wrote:

| never got percentage > 0%. Also the "Updated Objects seem not to be clear. It usually shows the number of nodes moved + 2.

this is because the new and the old parents are updated, too.

But in general the children and grand children are also somehow changed (at least the treeindex). The question is if we also want to include this
information. Maybe we could also adapt the report into something like "x taxa moved" instead of "x objects changed". Easier to read for the user. Also
we could split the information and say "x taxa have been moved with y children attached".

#17 - 06/15/2018 02:24 PM - Andreas Miiller

Katja Luther wrote:
Andreas Miiller wrote:
Katja Luther wrote:
Andreas Muller wrote:

Critical: when moving a taxon and its children (selected because the subtree was open) | would expect that the subtree structure
ist kept but it is not.

The taxa are added to the new parent all as direct children, loosing there own internal parent child relationship.

if you select only the parent the parent child relationship is kept. But if you select parent and children they all are moved to the new
parent.

Yes, | know, but the question is, how to improve this. The current situation may lead to unwanted data changes just because users don't
know/understand this behavior.

| would suggest to add something to the algorithm to check if a node which is within the multiselect has a parent/grandparent which is also
selected. If yes, we should not add it to the "move"-operation. Is this easy to check? Easiest would be to use the treeindex. Is it available in
the navigator? Or do we need a service layer method to collect all the "root" nodes for a given set of selected nodes?

I don't know, if this is the expected behaviour. If | select a node to move it as a child to another node | would expect that the node moves to this
new parent independent of its former parent.
But we can check whether one of the nodes is the parent of the other nodes, we have the treeindex available in the navigator.

It is true, that you may not know what is expected. But there is at least one dangerous usecase. The user selects a number of 100 taxa to move them
all by selecting the first and the last taxon. He/she may not realize that these taxa have expanded childnodes. But the multiselect automatically also
selects the child nodes if they are expanded. So the tree structure may change without the user realizing it.

What about checking for children in the selection and if there are children asking the user via dialog how to handle the "conflict". As selecting children
on purpose is expected to be a rare case this may not often interrupt the workflow.

#18 - 06/15/2018 02:51 PM - Andreas Miiller

By the way, performance is surprisingly good. Moving hundreds of taxa takes only 2-3 sec, even if most of them are root taxa.

Only problem with selecting many root taxa that the Ul becomes somehow unresponsive between drag and drop (and after drop if already before
unresponsive).

Probably this is an eclipse issue of the tree navigator?

#19 - 06/15/2018 03:03 PM - Andreas Miiller

- Description updated

We may also check, if the new parent node is already the old parent node. These nodes should not be moved (not critical as nothing wrong happens,
but better for performance, and also the reporting is more correct then)

#20 - 06/15/2018 03:40 PM - Andreas Miiller

Andreas Muller wrote:
While testing | got the following exception:

login : admin
editor version : 5.1.0.201806142059
server : test.e-taxonomy.eu (edit-test) / rem_conf_am
schema version : 5.0.0.0.20180514
os : Windows Server 2012 R2 6.3 amd64
jJava : 1.8.0_121
org.springframework.remoting.RemoteAccessException: Could not access HTTP invoker remote service at [http:
//test.e-taxonomy.eu:80/cdmserver/rem_conf_am/remoting/progressmonitor.service]; nested exception is java.
io.EOFException

at org.springframework.remoting.httpinvoker.HttpInvokerClientInterceptor.convertHttpInvokerAccessExcepti
on (HttpInvokerClientInterceptor.java:216)

at org.springframework.remoting.httpinvoker.HttpInvokerClientInterceptor.invoke (HttpInvokerClientInterce
ptor.java:147)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvocation. java:
179)
same happened at #6321#note-13

#21 - 06/15/2018 03:41 PM - Andreas Miiller

- Related to feature request #6321: Implement parallel loading + progress bar for loading objects into the bulk editor added

#22 - 06/18/2018 10:05 AM - Katja Luther

Katja Luther wrote:
Open issues:

Don't move (grand)child nodes of selected parents to the top level.
Exception in #7463#note-6

refresh after task end #7463#note-8

report (e.g. count of moved nodes)

(progress monitor shows correct percentage) ...

exclude move with new parent = old parent

e the count of the report only contains the moved nodes.
¢ children are kept as children of a moved parent
e drag & drop to same parent is not allowed

#23 - 06/18/2018 11:51 AM - Katja Luther

in classification combo, the classification of the first selected node is preselected, now.

#24 - 06/21/2018 01:37 PM - Andreas Miiller
- Description updated

The refresh issue still exists and is critical. It seems to happen with large subtrees. E.g. | moved Charyophyllaceae Juss. with all its >>100 children
from 1 classification to another. This took some time (percentage was at 100 for longer time before the job really finished, so we should also work on
the percentage computation, 100% should not be reached before the save has really finished - save takes long because many tree indexes need to
be recomputed).

Using refresh from menu did also not work. Only reopening navigator did solve the problem.

#25 - 06/21/2018 01:40 PM - Andreas Miiller

- Severity changed from normal to major

#26 - 06/21/2018 01:57 PM - Andreas Miiller

By the way, moving the 4 children of Charyophyllaceae Juss. results in relativ fast counting 25, 50, 75 and 100% and the 100% then waits for much
longer time. This also looks like the commit/save itself which maybe takes place at the service layer border as a "hidden" process is not really taken
into account. Maybe we could duplicate the number of steps, so moving takes altogether 50% and only after the final commit we add the other 50%.

Also the subtasks have no name. We could have something like "Move taxon x" where x is either a taxon name or, if not available the number 1/4, 2/4
... The final task can then be called e.g. "Saving and recomputing index".

#27 - 06/21/2018 04:39 PM - Katja Luther

Andreas Muller wrote:

By the way, moving the 4 children of Charyophyllaceae Juss. results in relativ fast counting 25, 50, 75 and 100% and the 100% then waits for
much longer time. This also looks like the commit/save itself which maybe takes place at the service layer border as a "hidden" process is not
really taken into account. Maybe we could duplicate the number of steps, so moving takes altogether 50% and only after the final commit we add
the other 50%.

Also the subtasks have no name. We could have something like "Move taxon x" where x is either a taxon name or, if not available the number
1/4, 2/4 ... The final task can then be called e.g. "Saving and recomputing index".

The "problem" is that the move taxon x tasks are really fast and the saving and reindexing is the time consuming task, so | think it is not necessary to
create a subtask for every taxonnode. Now | doubled the number of worksteps and added a subtask for the saving.
| also adapted the progress monitor on the editor side, and now the display in the status line should be the same as in the progress view.

#28 - 06/26/2018 04:34 PM - Katja Luther
- Status changed from Feedback to Resolved

- Assignee changed from Katja Luther to Andreas Miiller
now there are two subtasks: moving taxa and saving/reindexing, showing more subtasks are not really possible. please review

#29 - 06/26/2018 05:26 PM - Andreas Miiller
- Status changed from Resolved to Feedback

- Assignee changed from Andreas Miller to Katja Luther

Andreas Muller wrote:
The refresh issue still exists and is critical. It seems to happen with large subtrees. E.g. | moved Charyophyllaceae Juss. with all its >>100
children from 1 classification to another. This took some time (percentage was at 100 for longer time before the job really finished, so we should
also work on the percentage computation, 100% should not be reached before the save has really finished - save takes long because many tree
indexes need to be recomputed).
Using refresh from menu did also not work. Only reopening navigator did solve the problem.

This still happens though it does not happen always. Once the tree is opened at both places it does not happen but at beginning it may happen.

All the rest seems to work fine.

#30 - 06/28/2018 09:00 AM - Katja Luther
- % Done changed from 50 to 100

we have to have a look why the refresh sometimes does not work, therefore | create a new ticket and close this one (see #7521)

#31 - 06/28/2018 09:01 AM - Katja Luther
- Status changed from Feedback to Closed

#32 - 06/28/2018 09:01 AM - Katja Luther

- Related to bug #7521 refresh of taxonnavigator sometimes does not work for moving taxonnodes added
